part of viltage;

class Utility {
	static render(List<List<Entity>> entities, List<List<CharNode>> charArray) {
		for(int i = 0; i < entities.length; i++) {
			for(int j = 0; j < entities[i].length; j++) {
				entities[i][j].render(charArray);
			}
		}
	}
	  
	static draw(CanvasRenderingContext2D ctx, int offX, int offY, VilTAGE viltage) {
	  List<List<CharNode>> charArray = viltage.charArray;
	  List<List<CharNode>> charArray2 = viltage.charArray2;
        
		for(int i = 0; i < charArray.length; i++) {
			for(int j = 0; j < charArray[0].length; j++) {
			  if(!testDuplicate(charArray[i][j], charArray2[i][j])) {
/*					if(charArray[i][j].backgroundColor == "none") { 
  					ctx.fillStyle = viltage.backgroundColor;
  				} else {
  					ctx.fillStyle = charArray[i][j].backgroundColor;
  				}
					ctx.fillRect(j*offX, i*offY, (j+1)*offX, (i+1)*offY);
*/					
			  }
		    if(!testDuplicate(charArray[i][j], charArray2[i][j])) {
					ctx.fillStyle = charArray[i][j].color;
      		if(charArray[i][j].char.length > 1) {
      			charArray[i][j].char = " ";
      		}
      		ctx.fillText(charArray[i][j].char, j*offX, (i+1)*offY);
  				
  				charArray2[i][j] = charArray[i][j];
		    }
			}
		}
	    
		for(int i = 0; i < charArray.length; i++) {
			for(int j = 0; j < charArray[0].length; j++) {
			}
		}
	}
	
	static bool testDuplicate(CharNode charNode1, CharNode charNode2) {
	  bool duplicate = true;
	  if(charNode2 == null
	     || charNode1.char != charNode2.char
	     || charNode1.backgroundColor != charNode2.backgroundColor
	     || charNode1.color != charNode2.color
	     || charNode1.x != charNode2.x
	     || charNode1.y != charNode2.y) duplicate = false;
	  if(!duplicate) print("$duplicate");
	  return duplicate;
	}
	  
	static update(List<List<Entity>> entities, double delta) {
		for(int i = 0; i < entities.length; i++) {
			for(int j = 0; j < entities[i].length; j++) {
				entities[i][j].update(delta);
			}
		}
	}
}